using System;
using System.Collections.Generic;
namespace ExecFile
{
    public class ExecClass
    {
        static Serialize.Serialize Serialize = new Serialize.Serialize();
        static LibVars.LibVars Vars = new LibVars.LibVars();
        static Ssh.Ssh SshSite;
        static Ssh.Ssh SshBackup;

        public void ExecMethod(byte[] Arguments)
        {
            Vars = (LibVars.LibVars)Serialize.FromByte(Arguments);
            bool Go = true;
            int IndexString;
            string TmpString;
            string TimeString = String.Format("{0}_{1}", DateTime.Now.ToString("yyyyMMdd_HHmm"), Vars.Get("MySqlBaseName"));
            SshSite = new Ssh.Ssh(Vars.Get("HostSite"), int.Parse(Vars.Get("PortSite")), Vars.Get("UserNameSite"), Vars.Get("PasswordSite"));
            Vars.ReplaceFile(Vars.Get("WorkFolder") + "\\backup.tpl", Vars.Get("WorkFolder") + "\\script.sh");
            Go = SshSite.UploadFile(Vars.Get("WorkFolder") + "\\script.sh", "script.sh");
            System.IO.File.Delete(Vars.Get("WorkFolder") + "\\script.sh");
            if (!Go) { Console.WriteLine(SshSite.Logs); Console.WriteLine("Не удалось загрузить script.sh на сервер."); Environment.Exit(0); }

            SshSite.ExecCommand("chmod 744 script.sh");
            Go = SshSite.ExecCommand("./script.sh");
            SshSite.ExecCommand("rm script.sh");
            if (!Go) { Console.WriteLine(SshSite.Logs); Console.WriteLine("Ошибка во время выполненеия скрипта script.sh на сервере."); Environment.Exit(0); }

            string FolderBackup = Vars.Get("WorkFolder") + "\\" + TimeString;
            System.IO.Directory.CreateDirectory(FolderBackup);
            Go = SshSite.DownloadFile(Vars.Get("MySqlBaseName") + ".sql.gz", FolderBackup + "\\" + Vars.Get("MySqlBaseName") + ".sql.gz");
            if (!Go) { Console.WriteLine(SshSite.Logs); Console.WriteLine("Не удалось скачать " + Vars.Get("MySqlBaseName") + ".sql.gz"); Environment.Exit(0); }
            Go = SshSite.DownloadFile(Vars.Get("WorkFolderSite") + "/files.tar.gz", FolderBackup + "\\files.tar.gz");
            if (!Go) { Console.WriteLine(SshSite.Logs); Console.WriteLine("Не удалось скачать " + Vars.Get("WorkFolderSite") + "/files.tar.gz"); Environment.Exit(0); }
            SshSite.ExecCommand("rm " + Vars.Get("MySqlBaseName") + ".sql.gz");
            SshSite.ExecCommand("rm " + Vars.Get("WorkFolderSite") + "/files.tar.gz");
            Console.WriteLine(SshSite.Logs);

            SshBackup = new Ssh.Ssh(Vars.Get("HostBackup"), int.Parse(Vars.Get("PortBackup")), Vars.Get("UserNameBackup"), Vars.Get("PasswordBackup"));
            Go = SshBackup.UploadFolder(FolderBackup, Vars.Get("FolderBackupSite"));
            if (!Go) { Console.WriteLine(SshBackup.Logs); Console.WriteLine("Не удалось загрузить папку " + Vars.Get("FolderBackupSite") + " на бэкап сервер."); Environment.Exit(0); }
            SshBackup.LimitRemoteFolder(Vars.Get("FolderBackupSite"), int.Parse(Vars.Get("CountFolderBackupSite")));
            Console.WriteLine(SshBackup.Logs);
            System.IO.Directory.Delete(FolderBackup, true);
        }
    }
} 